PARSING_VERB_EXPECTED 	= 0
PARSING_UNKNOWN_WORD 	= 1
PARSING_UNDEFINED_IT 	= 2
PARSING_INVALID_AND		= 3
PARSING_OBJECT_MISSING	= 4
PARSING_UNDEFINED_ACTION = 5
PARSING_TOO_MANY_OBJECTS = 6
PARSING_UNDEFINED_AGAIN = 7
PARSING_GENERAL_ERROR = 8


function parse (text)
	text = string.gsub (text, ",", " and ")

	local state = 0
	local temp, verb, obj1, obj2, phrase
	local phrases = {}
	
	text = string.gsub (text, '%b""', function (s)
		table.insert (phrases, string.sub (s, 2, -2))
		return "#"
	end)
	
	for s in string.gfind (text, "%S+") do
		if state == 0 then
			obj1, obj2, phrase = nil, nil, nil
			verb = verbs:replace (s)
			if not verb then
				parsing_error (PARSING_VERB_EXPECTED, s)
				return
			end
			state = 1
		
		elseif state == 1 then
			temp = prepositions:replace (s)
			if temp then
				if not obj1 then
					obj1 = {prep = temp, nouns = {}}
				end
			else
				temp = nouns:replace (s)
				if temp then
					if not obj1 then
						obj1 = {nouns = {}}
					end
					table.insert (obj1.nouns, temp)
					state = 2
				else
					temp = special:replace (s)
					if temp == "it" then
						if not obj1 then
							obj1 = {}
						end
						if it then
							it.prep = obj1.prep
							obj1 = it
						else
							parsing_error (PARSING_UNDEFINED_IT)
							return
						end
						state = 2
					elseif temp == "then" or temp == "and" then
						post_parse (verb, obj1, obj2, phrase)
						state = 0
					
					elseif s == "#" then
						obj1 = nil
						phrase = phrases [1]
						table.remove (phrases, 1)
					
					else
						parsing_error (PARSING_UNKNOWN_WORD, s)
						return
					end
				end
			end
		
		elseif state == 2 then
			temp = prepositions:replace (s)
			if temp then
				obj2 = {prep = temp, nouns = {}}
				it = obj1
				state = 3
			else
				temp = nouns:replace (s)
				if temp then
					table.insert (obj1.nouns, temp)
				else
					temp = special:replace (s)
					if temp == "then" then
						post_parse (verb, obj1, obj2, phrase)
						it = obj1
						state = 0
					elseif temp == "and" then
						state = 4

					elseif s == "#" then
						if not obj1.nouns then
							obj1 = nil
						end
						phrase = phrases [1]
						table.remove (phrases, 1)
						
					else
						parsing_error (PARSING_UNKNOWN_WORD, s)
						return
					end
				end
			end
		
		elseif state == 3 then
			temp = nouns:replace (s)
			if temp then
				table.insert (obj2.nouns, temp)
			else
				temp = special:replace (s)
				if temp == "then" then
					post_parse (verb, obj1, obj2, phrase)
					it = obj1
					state = 0
				elseif temp == "it" then
					it.prep = obj2.prep
					obj2 = it
				elseif temp == "and" then
					state = 5
					
				elseif s == "#" then
					obj2 = nil
					phrase = phrases [1]
					table.remove (phrases, 1)
					
				else
					if prepositions:replace (s) then
					else
						parsing_error (PARSING_UNKNOWN_WORD, s)
						return
					end
				end
			end
		
		elseif state == 4 then
			temp = verbs:replace (s)
			if temp then
				post_parse (verb, obj1, obj2, phrase)
				it = obj1
				verb, obj1, obj2, phrase = temp
				state = 1
			else
				temp = nouns:replace (s)
				if temp then
					if not obj1.mult then
						obj1.mult = {}
					end
					table.insert (obj1.mult, {pos = table.getn (obj1.nouns), noun = temp})
					state = 2
				else
					temp = special:replace (s)
					if temp == "then" then
						
					else
						parsing_error (PARSING_INVALID_AND)
						return
					end
				end
			end
		
		elseif state == 5 then
			temp = verbs:replace (s)
			if temp then
				post_parse (verb, obj1, obj2, phrase)
				it = obj1
				verb, obj1, obj2, phrase = temp
				state = 1
			else
				temp = nouns:replace (s)
				if temp then
					if not obj2.mult then
						obj2.mult = {}
					end
					table.insert (obj2.mult, {pos = table.getn (obj2.nouns), noun = temp})
					state = 3
				else
					temp = special:replace (s)
					if temp == "then" then
						
					else
						parsing_error (PARSING_INVALID_AND)
						return
					end
				end
			end		
		
		
		elseif state == 6 then
		elseif state == 7 then
		end
	end
	
	it = obj1

	if obj2 and table.getn (obj2.nouns) == 0 then
		parsing_error (PARSING_GENERAL_ERROR)
		return
	end
	
	post_parse (verb, obj1, obj2, phrase)
end


function find_object (name)
	if table.getn (name) == 0 then
		return {player}
	end

	local next, objects = player.parent
	repeat
		objects = next:find (name)
		if next.parent then
			next = next.parent
		end
	until table.getn (objects) ~= 0 or next.parent ~= world
	
	if table.getn(objects) > 1 then
		for i, obj in ipairs(objects) do
			if obj:isme(name) then return {obj} end
		end
	end
	
	return objects
end


function post_parse (verb, obj1, obj2, phrase)
	if verb == "again" and not obj1 and not obj2 and not phrase then
		if not parsed_again then
			parsing_error (PARSING_UNDEFINED_AGAIN)			
			return
		end
		
		parsing_again = true
		post_parse (parsed_again[1], parsed_again[2], parsed_again[3], parsed_again[4])
		parsing_again = false
		return
	end
	if not parsing_again then
		parsed_again = {verb, obj1, obj2, phrase}
	end
	
	if obj1 and obj1.mult then
		local mult = obj1.mult
		obj1.mult = nil
		post_parse (verb, obj1, obj2, phrase)
		for i, p in ipairs (mult) do
			obj1.nouns [p.pos], p.noun = p.noun, obj1.nouns [p.pos]
			post_parse (verb, obj1, obj2, phrase)
		end
		obj1.mult = mult
		return
	end

	if obj2 and obj2.mult then
		local mult = obj2.mult
		obj2.mult = nil
		post_parse (verb, obj1, obj2, phrase)
		for i, p in ipairs (mult) do
			obj2.nouns [p.pos], p.noun = p.noun, obj2.nouns [p.pos]
			post_parse (verb, obj1, obj2, phrase)
		end
		obj2.mult = mult
		return
	end

	if obj1 then
		obj1.object = nil
		if obj2 then
			obj2.object = nil
		end
		local objects
		
		local all = false
		if obj1 and obj1.nouns [1] == "all" then
			all = true
		end
		
		objects = find_object (obj1.nouns)
		if table.getn (objects) == 1 then
			obj1.object = objects [1]
		
		elseif  all and table.getn (objects) > 0 then
			if obj2 and not obj2.object then
				local objects = find_object (obj2.nouns)
				if table.getn (objects) == 1 then
					obj2.object = objects [1]
				end
			end
			
			for i, obj in ipairs (objects) do
				obj1.object = obj
				do_parsed (verb, obj1, obj2, phrase)
			end
			return
			
		elseif not obj2 then
				local name1, name2 = clone (obj1.nouns), {}
				for i=1, table.getn (name1) do
					objects = find_object (name1)
					if table.getn (objects) == 1 then
						obj1.object = objects [1]
						obj2 = {nouns = clone (name2)}
						objects = find_object (name2)
						if table.getn (objects) == 1 then
							obj2 = {nouns = name2, object = objects [1]}
							obj1.nouns = name1
							break
						end
					end
					table.insert (name2, name1 [table.getn (name1)])
					table.remove (name1)
				end
		end
			
		if not obj1.object then
			objects = find_object (obj1.nouns)
			if table.getn(objects) == 0 then
				parsing_error (PARSING_OBJECT_MISSING, table.concat (obj1.nouns, " "))
			else
				parsing_error (PARSING_TOO_MANY_OBJECTS, objects)
			end
			return
		end
		
		if obj2 and not obj2.object then
			objects = find_object (obj2.nouns)
			if table.getn (objects) == 1 then
				obj2.object = objects [1]
			else
				obj2.objects = objects
			end
		end
	end
	
	do_parsed (verb, obj1, obj2, phrase)
end


function do_parsed (verb, obj1, obj2, phrase)
	local event, object = {prep = {}}, player
	event.verb = verb
	event.default = true
	if obj2 then
		event.prep [2] = obj2.prep
		event.name = obj2.nouns
		event.object = obj2.object
		event.objects = obj2.objects
	end
	
	if obj1 then
		event.prep [1] = obj1.prep
		event.default = nil
		object = obj1.object
	end
	
	if phrase then
		event.phrase = phrase
	end
	
	local next, hevent = object, copy (event)
	hevent.verb = verb
	hevent.target = object
	hevent.before = true
	repeat
		if next.hooks then
			for i=1,table.getn (next.hooks) do
				if not next.hooks [i] (hevent) then
					return
				end
			end
		end
		
		next = next.parent
	until not next
	
	if object [verb] then
		if type(object[verb]) == "function" then
			object [verb] (object, event)
		else
			print (object [verb])
		end
	else
		parsing_error (PARSING_UNDEFINED_ACTION, {verb, object.name})
		return
	end

	hevent.before = nil
	hevent.after = true
	next = object
	repeat
		if next.hooks then
			for i=1,table.getn (next.hooks) do
				next.hooks [i] (hevent)
			end
		end
		
		next = next.parent
	until not next
end


function parsing_error (err, detail)
	if err == PARSING_VERB_EXPECTED then
		print ("error: unknown verb '"..detail.."'")
	elseif err == PARSING_UNKNOWN_WORD then
		print ("error: unknown word '"..detail.."'")
	elseif err == PARSING_UNDEFINED_IT then
		print "error: undefined 'it'"
	elseif err == PARSING_INVALID_AND then
		print "error: invalid using of 'and'"
	elseif err == PARSING_OBJECT_MISSING then
		print ("error: couldn't find object '"..detail.."'")
	elseif err == PARSING_UNDEFINED_ACTION then
		print ("error: undefined action '"..detail [1].."' of object '"..detail [2].."'" )
	elseif err == PARSING_TOO_MANY_OBJECTS then
		print "error: too many objects on the scene:"
		for i, v in ipairs( detail ) do
			print (v.name)
		end
	elseif err == PARSING_UNDEFINED_AGAIN then
		print "error: undefined again"
	elseif err == PARSING_GENERAL_ERROR then
		print "error: syntax error"

	end
end

--=================================================================================================
vocabulary = {}


function vocabulary:add (template)
	if type (template) == "table" then		
		table.insert (self, template)
	else
		if string.sub (template, -1) ~= "\n" then
			template = template.."\n"
		end

		local templ 
		for s in string.gfind (template, "(.-)\n") do
			templ = {}
			for s in string.gfind (s, "%S+") do
				table.insert (templ, s)
			end
			self:add (templ)
		end
	end
end


function vocabulary:replace (word)
	local left, right
	for i, template in ipairs (self) do
		for i, t in ipairs (template) do
			left, right = false, false
			if string.sub (t, 1, 1) == "*" then
				left = true
				t = string.sub (t, 2)
			end
			if string.sub (t, -1) == "*" then
				right = true
				t = string.sub (t, 1, -2)
			end
			
			if left and right then
				if string.find (word, t) then
					return template[1]
				end
			elseif left then
				if t == string.sub (word, -string.len (t)) then
					return template[1]
				end
			elseif right then
				if t == string.sub (word, 1, string.len(t)) then
					return template[1]
				end
			else
				if word == t then
					return template[1]
				end
			end
		end
	end
end


function vocabulary:check ()
	for i, template in ipairs (self) do
		for j, t in ipairs (template) do
			t = string.gsub (t, "*", "")
			if t ~= self:checking_replace (t, i) then
				print ("error in word "..template[1]..": it replaces by "..self:checking_replace(t, i))
			end
		end
	end
end



function vocabulary:checking_replace (word, line)
	local left, right
	for i, template in ipairs (self) do
		if i ~= line then
			for i, t in ipairs (template) do
				left, right = false, false
				if string.sub (t, 1, 1) == "*" then
					left = true
					t = string.sub (t, 2)
				end
				if string.sub (t, -1) == "*" then
					right = true
					t = string.sub (t, 1, -2)
				end
				
				if left and right then
					if string.find (word, t) then
						return template[1]
					end
				elseif left then
					if t == string.sub (word, -string.len (t)) then
						return template[1]
					end
				elseif right then
					if t == string.sub (word, 1, string.len(t)) then
						return template[1]
					end
				else
					if word == t then
						return template[1]
					end
				end
			end
		end
	end
	return word
end


--=================================================================================================
dofile "verbs.lua"
dofile "nouns.lua"
dofile "prepositions.lua"
dofile "special.lua"
