#!/usr/bin/wxlua
-- =========================================================================================

if not wx then require "wx" end; wxr = { }

-- =========================================================================================

wxr.vars = {
	version		= "0.11.027",
	copyright	= "(c) barabanus, 2008",

	fontface 	= "Arial",
	fontsize	= 4,
	bgcolor 	= "#00007D",
	fgcolor 	= "#ffffff",

	width 		= 500,
	height 		= 500,
}
wxr.vars.title 	= "SixDays Runner v"..wxr.vars.version

-- =========================================================================================
-- =========================================================================================

wxr.ansi = {
	[0x0410] = "",	[0x0430] = "",	[0x0411] = "",	[0x0431] = "",
	[0x0412] = "",	[0x0432] = "",	[0x0413] = "",	[0x0433] = "",
	[0x0414] = "",	[0x0434] = "",	[0x0415] = "",	[0x0435] = "",
	[0x0401] = "",	[0x0451] = "",	[0x0416] = "",	[0x0436] = "",
	[0x0417] = "",	[0x0437] = "",	[0x0418] = "",	[0x0438] = "",
	[0x0419] = "",	[0x0439] = "",	[0x041A] = "",	[0x043A] = "",
	[0x041B] = "",	[0x043B] = "",	[0x041C] = "",	[0x043C] = "",
	[0x041D] = "",	[0x043D] = "",	[0x041E] = "",	[0x043E] = "",
	[0x041F] = "",	[0x043F] = "",	[0x0420] = "",	[0x0440] = "",
	[0x0421] = "",	[0x0441] = "",	[0x0422] = "",	[0x0442] = "",
	[0x0423] = "",	[0x0443] = "",	[0x0424] = "",	[0x0444] = "",
	[0x0425] = "",	[0x0445] = "",	[0x0426] = "",	[0x0446] = "",
	[0x0427] = "",	[0x0447] = "",	[0x0428] = "",	[0x0448] = "",
	[0x0429] = "",	[0x0449] = "",	[0x042A] = "",	[0x044A] = "",
	[0x042B] = "",	[0x044B] = "",	[0x042C] = "",	[0x044C] = "",
	[0x042D] = "",	[0x044D] = "",	[0x042E] = "",	[0x044E] = "",
	[0x042F] = "",	[0x044F] = "",	[0x0406] = "",	[0x0456] = "",
	[0x0407] = "",	[0x0457] = "",	[0x0490] = "",	[0x0491] = "",
	[0x0404] = "",	[0x0454] = "",
}

wxr.uniexp = ""
wxr.uni = { }; for k, v in pairs(wxr.ansi) do 
	wxr.uni[v], wxr.uniexp = ("&#%d;"):format(k), wxr.uniexp..v
end

wxr.uniexp = "["..wxr.uniexp.."]"

-- =========================================================================================

function wxr:tohtml( text, plain )
	if plain then
		text = text:gsub("&", "&amp;"):gsub("<", "&lt;"):gsub(">", "&gt;")
		text = text:gsub("(%S) (%S)","%1&#32;%2"):gsub(" ", "&nbsp;")
	end
	return text:gsub(wxr.uniexp, wxr.uni)
end

-- =========================================================================================

function wxr:toansi( text )
	local ansi, byte, word = ""
	local skip = false
	
	for i = 1, #text do
		if not skip then
			byte = text:byte(i)
			if byte == 208 or byte == 209 then
				if i ~= #text then
					word = math.mod(byte, 32) * 64 + math.mod(text:byte(i+1), 64)
					if wxr.ansi[word] then ansi = ansi..wxr.ansi[word] end
					skip = true
				end
			else
				ansi = ansi..text:sub(i, i)
			end
		else
			skip = false
		end
	end
	
	return ansi
end

-- =========================================================================================
-- =========================================================================================

function wxr : lift_eyelids()
	x:body [[
<table cellspacing=0 cellpadding=0 width=100%><tr>
<td>$(title)<br>$(copyright)
<td align=right><img src="logo-inv.gif">
</table>
<p>$(input)
<p><table width=100% height=300 cellpadding=0 bgcolor=#777777><tr><td>
<table width=100% cellpadding=3 cellsizing=0 bgcolor=$(bgcolor)><tr><td>$(output)</table>
</table>
]]

	local std = "&nbsp;"
	
	_G.print = function(...)
		for i, a in ipairs(arg) do arg[i] = tostring(a) end
		local text = table.concat(arg, "<td>")
		x:pln(#text>0 and text or "&nbsp;")
	end
	
	local fenv = setmetatable({ }, { __index = _G })
	
	x:on_input( function(text)
		x:clear()
		local f, e, r = loadstring(text)
		if not f then return x:p(e) end
		f, e = pcall(setfenv(f, fenv))
		if not f then return x:p(e) end
		if #wxr.vars.print == 0 then x:pln(std) end
		wxr.vars.print = wxr.vars.print:gsub("<br>$",""):gsub("<br>","<tr><td>")
	end)
	
	x:pln("Welcome to ".._VERSION.." console")
end

-- =========================================================================================
-- =========================================================================================

wxr.input = { it = 0, pre = "", post = "" }

-- =========================================================================================

function wxr.on_key_html( event )
	event:Skip(true)
	if event:GetKeyCode() == wx.WXK_CONTROL then return	end
	wxr.wnd.input:SetFocus()
	wxr.wnd.input:EmulateKeyPress( event )
end

-- =========================================================================================

function wxr : scroll( d )
	local x, y = wnd.html:GetViewStart()
	wnd.html:Scroll( 0, y+d )
end

-- =========================================================================================

wxr.onkey = {
	[wx.WXK_BACK] 	= function() return input.pre:sub(1,-2), input.post end,
	[wx.WXK_DELETE]	= function() return input.pre, input.post:sub(2) end,
	[wx.WXK_LEFT]	= function() return input.pre:sub(1,-2), input.pre:sub(-1,-1)..input.post end,
	[wx.WXK_RIGHT]	= function() return input.pre..input.post:sub(1,1), input.post:sub(2) end,
	[wx.WXK_HOME]	= function() return "", input.pre..input.post end,
	[wx.WXK_END]	= function() return input.pre..input.post, "" end,
	[wx.WXK_UP]		= function()
						if input.it == 0 then input[0] = input.pre..input.post end
						input.it = math.min(input.it+1, #input+1)
						return input.it<=#input and wxr.input[input.it] or "", ""
					end,
	[wx.WXK_DOWN]	= function()
						local text = (input.it > 0) and input[input.it-1] or input.pre..input.post
						input.it = math.max(input.it-1, 0)
						return text, ""
					end,
	[wx.WXK_ESCAPE]	= function() return "", "", wnd.main:Close() end,
	[wx.WXK_PAGEUP] = function() return "", "", wxr:scroll(-5) end,
	[wx.WXK_PAGEDOWN] = function() return "", "", wxr:scroll(5) end,
}

function wxr.on_key_input( event )
	local code = event:GetKeyCode()
	
	if wxr.pending and code ~= wx.WXK_ESCAPE then
		wxr.vars.print, wxr.pending = wxr.vars.print..wxr.pending
		wxr:postprint()
		wxr:update()
		return event:Skip(false)
	end
	
	-- SPECIAL
	if wxr.onkey[code] then
		wxr.input.pre, wxr.input.post = wxr.onkey[code]()
		
	-- RETURN
	elseif code == wx.WXK_RETURN then
		local input = wxr.input.pre..wxr.input.post
		if #input==0 then return end
		if input ~= wxr.input[1] then table.insert(wxr.input, 1, input) end
		wxr.input.it = 0
		if wxr.on_input then wxr.on_input( input ) end
		wxr:postprint()
		wxr.input.pre, wxr.input.cur, wxr.input.post = "", "", ""
		
	-- CTRL-C
	elseif event:ControlDown() and code == 3 then
		wxr.ctrlc = true
			local text = wxr.wnd.html:SelectionToText()
			wxr.wnd.input:SetValue(text)
			wxr.wnd.input:SetSelection(-1,-1)
			wxr.wnd.input:Cut()
		wxr.ctrlc = false
		
	-- CTRL-V
	elseif event:ControlDown() and code == 22 then
		wxr.ctrlv = true
			wxr.wnd.input:Paste()
			local text = wxr:toansi(wxr.wnd.input:GetValue())
			wxr.wnd.input:Clear()
		wxr.ctrlv = false
		wxr.input.pre = wxr.input.pre..text
		
	else return event:Skip(true)
	end	
	
	wxr:update()
	event:Skip(false)
end

-- =========================================================================================

function wxr.on_char_input( event )
	if wxr.ctrlc or wxr.ctrlv then return end
	local char = wxr:toansi(wxr.wnd.input:GetValue())
	if #char == 0 then return end
	wxr.input.pre = wxr.input.pre..char
	wxr.wnd.input:Clear()
	wxr:update()
end

-- =========================================================================================

wxr.vars.anykey = "[<i>Press&nbsp;any&nbsp;key</i>]"

function wxr:update_input()
	if wxr.pending then
		vars.sym, vars.pre, vars.cur = "", "$(anykey)", ""
		return
	end
	
	vars.sym = "<td>&gt;<td width=2>"
	local pre = (#input.pre>0) and "<td>"..wxr:tohtml(input.pre, true) or ""
	if #input.post == 0 then
		if #pre>0 then pre = pre.."<td width=2>" end
		vars.pre, vars.cur, vars.post = pre, "&nbsp;&nbsp;", ""
	else
		local cur = input.post:sub(1,1)
		cur = (cur == " ") and "&nbsp;" or wxr:tohtml(cur, true)
		local post = input.post:sub(2)
		post = (#post>0) and "<td>"..wxr:tohtml(post, true) or ""
		vars.pre, vars.cur, vars.post = pre, cur, post
	end
end

-- =========================================================================================
-- =========================================================================================

wxr.tags = { open = { }, close = { }, }
wxr.vars.print, wxr.vars.cleared = "", ""

-- =========================================================================================

function wxr.tags : add( tag, value )
	self.open[tag] = value
	local close = ""
	for expr in value:gmatch "%b<>" do
		for tag in expr:gmatch "<%s*([%w_]+)" do
			close = ("</%s>%s"):format(tag, close)
		end
	end
	self.close[tag] = close
end

-- =========================================================================================

function wxr : postprint()
	local output, p1, p2 = vars.print
		
	p1, p2 = output:find "<%s*stop%s*>"
	if p1 and p2 then
		vars.print = output:sub(1, p1-1)
		wxr.pending = output:sub(p2+1)
		wxr:postprint()
		return
	end
	
	p1, p2 = output:find "<%s*clear%s*>"
	if p1 and p2 then
		vars.print = output:sub(p2+1)
		wxr:postprint()
		return
	end
	
	output = output:gsub("<br>","\n"):gsub("(%s+)$",""):gsub("\n","<br>")
	vars.output = wxr:gsubvars( output )
end

-- =========================================================================================

function wxr : print( text )
	text = tostring(text):gsub("\n","<br>")
	vars.print = vars.print..text
	wxr.blind = false
end

-- =========================================================================================

function wxr : clear() vars.print, vars.cleared, wxr.blind = "", vars.print, false end
function wxr : restore() vars.print, wxr.blind = vars.cleared, false end

-- =========================================================================================
-- =========================================================================================

x = { }

-- =========================================================================================

function x:border(w) wxr.wnd.html:SetBorders(w) end
function x:pln(text) wxr:print(text.."\n") end
function x:p(text) wxr:print(text) end
function x:restore() wxr:restore() end
function x:clear() wxr:clear() end
x.print, x.println = x.p, x.pln

local wxr_xcolor = function(field, color)
	wxr.newage[field], wxr.blind = color, false
	wxr:newage()
end

function x:fgcolor(color) wxr_xcolor( "fgcolor", color ) end
function x:bgcolor(color) wxr_xcolor( "bgcolor", color ) end

function x:on_input(f)
	assert(type(f)=="function", "on_input handler must be function( text )")
	wxr.on_input = f
end

-- =========================================================================================

local x_tags = { }
setmetatable(x_tags, {
	__newindex = function(t,k,v)
		assert(type(k)=="string" and type(v)=="string", "key and value must be strings")
		wxr.tags:add(k, v)
	end
})

-- =========================================================================================

local x_index = { tags = x_tags, }
setmetatable(x, {
	__index = function(t,k)
		if x_index[k] then return x_index[k] end
		return function(self, text) wxr.vars[k] = text; wxr.blind = false end
	end,
	__newindex = function(t,k,v)
		assert(false, "wxRunner's interface is read-only")
	end,
})

-- =========================================================================================
-- =========================================================================================

wxr.newage = { 
	fgcolor = wxr.vars.fgcolor,
	bgcolor = wxr.vars.bgcolor,
}

setmetatable(wxr.newage, { __call = function() 
	if wxr.started 
	then wxr.wnd.timer:Start( 15 )
	else 
		wxr.vars.fgcolor = wxr.newage.fgcolor
		wxr.vars.bgcolor = wxr.newage.bgcolor
	end
end })

-- =========================================================================================

local wxr_lerp_int = function(lo, hi, val) return math.modf(lo + (hi-lo)*val) end

local wxr_lerp_color = function( src, dst, val )
	src, dst = wx.wxColour(src), wx.wxColour(dst)
	local r1, g1, b1 = src:Red(), src:Green(), src:Blue()
	local r2, g2, b2 = dst:Red(), dst:Green(), dst:Blue()
	
	local r3 = wxr_lerp_int(r1, r2, val)
	local g3 = wxr_lerp_int(g1, g2, val)
	local b3 = wxr_lerp_int(b1, b2, val)
	
	local flag = false
	if math.abs(r3-r2) < 5 and math.abs(g3-g2) < 5 and math.abs(b3-b2) < 5 then
		r3, g3, b3, flag = r2, g2, b2, true
	end
	
	return ("#%02x%02x%02x"):format(r3, g3, b3), flag
end

function wxr.on_timer( event )
	if wxr.ontimer then 
		wxr.wnd.timer:Stop()
		wxr.ontimer = false
		return
	end
	wxr.ontimer = true
	
	local f1, f2
	wxr.vars.fgcolor, f1 = wxr_lerp_color(wxr.vars.fgcolor, wxr.newage.fgcolor, 0.2)
	wxr.vars.bgcolor, f2 = wxr_lerp_color(wxr.vars.bgcolor, wxr.newage.bgcolor, 0.2)
	if f1 and f2 then wxr.wnd.timer:Stop() end
	wxr:update()
	
	wxr.ontimer = false
end

-- =========================================================================================
-- =========================================================================================

wxr.tags:add( "wxrerror", "<table><tr><td bgcolor=red><font color=white>" )

local wxr_vars_env = setmetatable({ }, {
	__index = function(t,k)
		return wxr.vars[k] or _G[k] or ""
	end,
})

local wxr_gsub_vars = function( expr )
	local f, e, r = loadstring("return "..expr:sub(2,-2))
	if not f then return "<wxrerror>"..e.."</wxrerror>" end
	f, e = pcall(setfenv(f, wxr_vars_env))
	if not f then return "<wxrerror>"..e.."</wxrerror>" end
	return e and wxr:tohtml(tostring(e)) or ""
end

local wxr_gsub_tags = function( expr )
	for flag, tag in expr:gmatch "<%s*([/]*)%s*([%w_]+)" do
		local page = (#flag==0) and "open" or "close"
		if wxr.tags[page][tag] then return wxr.tags[page][tag] end
	end
	return expr
end

-- =========================================================================================

function wxr:gsubvars( text )
	local ctr, num = 10
	repeat ctr = ctr-1
		text, num = text:gsub("%b<>", wxr_gsub_tags):gsub("%$(%b())", wxr_gsub_vars)
	until ctr==0 or num == 0
	return text
end

-- =========================================================================================
-- =========================================================================================

wxr.vars.html = [[
<html>
	<head>
		<title>$(title) $(copyright)</title>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-16">
	</head>
	
	<body bgcolor=$(bgcolor) text=$(fgcolor)>
		<font size=$(fontsize) face="$(fontface)">
			$(body)
		</font>
	</body>
</html>]]

wxr.vars.input = ([[
<table cellspacing=0 cellpadding=0>
	<tr>$(sym)
	$(pre)
	<td bgcolor=$(fgcolor)><font color=$(bgcolor)>$(cur)</font>
	$(post)
</table>]]):gsub("[\t\n]","")

wxr.vars.body = [[
$(output)
$(input)
]]

-- =========================================================================================

wxr.wnd = {	main, html, input = nil, nil, nil }

-- =========================================================================================

function wxr : update()
	wxr:update_input()
	
	local html = wxr:gsubvars(vars.html)
	
	wnd.html:Freeze()
		local size = wnd.html:GetVirtualSize()
		local x, y = wnd.html:GetViewStart()
		local h = wnd.html:GetClientSize():GetHeight()
		local ux, uy = wnd.html:GetScrollPixelsPerUnit()
		local bottom = y*uy + h > size:GetHeight()
		
		wnd.html:SetPage(html)
		
		if bottom then
			size = wnd.html:GetVirtualSize()
			y = math.modf(math.max(0, (size:GetHeight()-h)/uy)) + 1
		end
		
		wnd.html:Scroll( x, y )
	wnd.html:Thaw()
end

-- =========================================================================================

function wxr : start()
	wxr.started = true
	wnd.main = wx.wxFrame( wx.NULL, wx.wxID_ANY, vars.title, wx.wxDefaultPosition, 
		wx.wxSize(vars.width, vars.height), wx.wxMINIMIZE_BOX + wx.wxSYSTEM_MENU 
		+ wx.wxCAPTION + wx.wxCLOSE_BOX + wx.wxCLIP_CHILDREN )
	
	local icon = wx.wxIcon( "LUA", wx.wxBITMAP_TYPE_ICO_RESOURCE )
	wnd.main:SetIcon( icon )
	
	wnd.timer = wx.wxTimer( wnd.main )
	wnd.main:Connect( wx.wxID_ANY, wx.wxEVT_TIMER, wxr.on_timer )
	wxr:newage()
	
	wnd.html = wx.wxLuaHtmlWindow( wnd.main )
	wnd.html:Connect( wx.wxID_ANY, wx.wxEVT_KEY_DOWN, wxr.on_key_html )
	update()
	
	wnd.main:Show( true )
	
	wnd.input = wx.wxTextCtrl( wnd.main, wx.wxID_ANY, "", wx.wxPoint(10000,10000) )
	wnd.input:Connect( wx.wxID_ANY, wx.wxEVT_CHAR, wxr.on_key_input )
	wnd.input:Connect( wx.wxID_ANY, wx.wxEVT_COMMAND_TEXT_UPDATED, wxr.on_char_input )
	wnd.input:SetFocus()
	
	wx.wxGetApp():MainLoop()
end

-- =========================================================================================

wxr.fenv = setmetatable({ }, {
	__index = function( t,k )
		local v = wxr[k]
		return (v ~= nil) and v or _G[k]
	end
})

local wxr_setfenv = function(table)
	for k, v in pairs(table) do
		if type(v) == "function" then setfenv(v, wxr.fenv) end
	end
end

wxr_setfenv(wxr)
wxr_setfenv(wxr.onkey)

-- =========================================================================================

wxr.blind = true
if arg[1] then
	if arg[1] ~= "-std" then
		wxr.script = arg[1]
		dofile(arg[1])
	end
else
	local frame = wx.wxFrame(  wx.NULL, wx.wxID_ANY, wxr.vars.title, 
		wx.wxDefaultPosition, wx.wxSize(0,0), wx.wxCAPTION )
	local dialog = wx.wxFileDialog( frame, "Open a script",
		"", "", "Lua files (*.lua)|*.lua",
		wx.wxOPEN + wx.wxFILE_MUST_EXIST )
	if dialog:ShowModal() == wx.wxID_OK then
		wxr.script = wxr:toansi(dialog:GetPath())
		dofile(wxr.script)
	end
	dialog:Destroy()
	frame:Destroy()
end

if wxr.blind then
	if wxr.script then
		local caption = wxr.script.." use no wxRunner"
		local flags = wx.wxICON_ERROR + wx.wxOK
		local dialog = wx.wxMessageDialog( wx.NULL, caption, wxr.vars.title, flags )
		local res = dialog:ShowModal()
		dialog:Destroy()
		os.exit()
	else
		wxr:lift_eyelids()
	end
end

-- =========================================================================================

wxr:postprint()
wxr:start()

-- =========================================================================================