_ALERT = function (mes)
	error_print (mes)
end

dofile "if.lua"

function empty () end

setfontsize = empty
setfontcolor = empty
setfontbold = empty
setfontitalic = empty
setfontunderline = empty
setcenteralign = empty
setrightalign = empty

filename = ""
temp = ""


IDE_MAP = {cur_page = -1}

function IDE_MAP:add (obj1, obj2)
	if (obj2) then
		for k, v in self[self.cur_page].links do
			if (v[1] == obj1 and v[2] == obj2) or
		   	   (v[2] == obj1 and v[1] == obj2) then
				table.remove (self[self.cur_page].links, k)
				return
			end
		end

		table.insert (self[self.cur_page].links, {obj1, obj2})
	else
		for k, v in self[self.cur_page].objects do
			if v == obj1 then
				return
			end
		end
		table.insert (self[self.cur_page].objects, {name = obj1})
	end
end


function IDE_MAP:delete (obj)
	local kill = {}
	for k, v in self[self.cur_page].links do
		if v[1] == obj or v[2] == obj then
			table.insert (kill, k)
		end
	end

	for i=1,table.getn (kill) do
		table.remove (self[self.cur_page].links, kill[i] - (i-1))
	end

	for k, v in self[self.cur_page].objects do
		if v.name == obj then
			table.remove (self[self.cur_page].objects, k)
			return
		end
	end
end


function IDE_MAP:draw ()
	for k, v in self[self.cur_page].links do
		mapdrawline (v[1], v[2])
	end
end


function IDE_MAP:add_page (name)
	table.insert (self, {name = name, links = {}, objects = {}})
end


function IDE_MAP:update ()
	clearpageslist ()
	for i=1, table.getn(self) do
		addmappage (self[i].name);
	end
end


function IDE_MAP:select (num)
	if self.cur_page ~= -1 then
		self:saveitems ()
	end
	self.cur_page = num
	writepagename (self[self.cur_page].name)
	clearpageitems ()
	for k, v in self[self.cur_page].objects do
		addpageitem (v.name, v.x, v.y)
	end
end


function IDE_MAP:saveitems ()
	local name, x, y
	for i=1, pageitemscount() do
		name, x, y = getpageitem (i) 
		for k, v in self[self.cur_page].objects do
			if v.name == name then
				v.x, v.y = x, y
				break
			end
		end
	end
end


function IDE_MAP:delete_page (num)
	if num ~= 1 then
		table.remove (self, num)
		self.cur_page = -1
		self:select (num-1)
		self:update ()
	end
end


IDE_MAP:add_page ""
IDE_MAP:update ()
IDE_MAP:select (1)