function clone (x, init)
	local r = {}
	for k, v in pairs( x ) do
		if type(v) == "table" then
			r[k] = clone (v)
		else  r[k] = v             
		end
	end
	if init then
		for k, v in pairs( init ) do
			r[k] = v
		end
	end
	setmetatable (r, getmetatable(x))
	return r
end


function copy (x)
	local r = {}
	for k, v in pairs( x ) do
		r[k] = v
	end
	setmetatable (r, getmetatable(x))
	return r
end


function show_table (table)
	for i, v in pairs( table ) do
		print (i, v)
	end
end


function dump_table (table, file)
	file:write ("{\n")
	for k, v in pairs( table ) do
		if type (v) == "number" then
			if type (k) == "string" then
				file:write (k.." = "..v..",\n")
			else
				file:write ("["..k.."] = "..v..",\n")
			end
		elseif type (v) == "string" then
			if type (k) == "string" then
				file:write (k.." = [["..v.."]],\n")
			else
				file:write ("["..k.."] = [["..v.."]],\n")
			end
		elseif type (v) == "table" then
			if type (k) == "string" then
				file:write (k.." = ")
			else	
				file:write ("["..k.."] = ")
			end
			dump_table (v, file)
			file:write (",\n")
		elseif type (v) == "boolean" then
			if v then
				file:write (k.." = true,\n")
			else
				file:write (k.." = false,\n")
			end
		end
	end
	file:write ("}")
end